local HardFinger = _G.HardFinger
local P = HardFinger.HardFinger_Config

HardFinger.ENCOUNTERS_ID = {
["EMERALD"] = {1873, 1877, 1864}, -- EN
["TOV"] = {1958, 1962, 2008}, -- TOV
["NH"] = {1849, 1865, 1867, 1871, 1862, 1842, 1886, 1872, 1863, 1866}, -- NH
}

COMBATLOG_OBJECT_TYPE_PET		= COMBATLOG_OBJECT_TYPE_PET or 0x00001000

COMBATLOG_OBJECT_TYPE_GUARDIAN		= COMBATLOG_OBJECT_TYPE_GUARDIAN or 0x00002000

COMBATLOG_OBJECT_TYPE_NPC 		= COMBATLOG_OBJECT_TYPE_NPC or 0x0000800

PET_FILTER_BITMASK			= COMBATLOG_OBJECT_TYPE_PET + COMBATLOG_OBJECT_TYPE_GUARDIAN + COMBATLOG_OBJECT_TYPE_NPC

COMBATLOG_OBJECT_REACTION_FRIENDLY	= COMBATLOG_OBJECT_REACTION_FRIENDLY or 0x00000010



function HardFinger.IsIn(object, table)
    if type(table) == "string" then
        return object == table
    end
    local result = false
    for _,v in pairs(table) do
        if v == object then
            result = true
            break
        end
        
    end
    return result
end

--message, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, param12, param13, param14 = ...

function HardFinger.BadSpellHitID(spellToTrack, amountThreshold, roles, shouldShow, shouldTrack, sourceName, destName, spellID, damageAmount, overKillAmount, absorbAmount)
	if spellToTrack == spellID and message == "SPELL_DAMAGE" and bit.band(destFlags, PET_FILTER_BITMASK) == 0 then

		local role = UnitGroupRolesAssigned(destName)
		local absorbed = absorbAmount or 0
		local overkill = overKillAmount or 0

		local damageTaken = damageAmount + absorbed

		destName = HardFinger.SName(destName) -- Strip away realm name
		if overkill > 0 then

			if shouldShow == true then

				HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." Overkill: "..HardFinger.FormatDamage(damageTaken)..".", pChannel)
			end

			if shouldTrack == true then
				HardFinger.ModifyFailTable(spellID, "Deaths: ", destName)
				HardFinger.ModifyFailTable(spellID, "Total times hit: ", destName)
			end

		elseif string.find(string.upper(roles),string.upper(role)) or roles == "ALL" then
			if damageTaken >= amountThreshold then

				if shouldShow == true then
					HardFinger.SendChat(destName.." failed miserably. "..GetSpellLink(spellID).." hit for "..HardFinger.FormatDamage(damageTaken)..".", pChannel)

				end

				if shouldTrack == true then
					HardFinger.ModifyFailTable(spellID, "Total times hit: ", destName)

				end
			end
		end

	end

end


function HardFinger.toggletf(variable)
	if variable ~= true then		return true	else		return false	end
end

function HardFinger.toggle01(variable)
	if variable ~= 1 then		return 1	else		return 0	end
end


function HardFinger.StatusText(variable)
	if variable ~= 1 and variable ~= true then
		return "|cffff0000Off"
	else
		return "|c0000FF00On"
	end
end

-- Funcao remove from table

function HardFinger.RemoveFromTableIDbyEvent(tableToModify, event, spellIDToTrack, message, tableKey, spellID)

	if tableToModify == nil then
		return

	end

	if spellIDToTrack == spellID and string.find(event,message) then
		if tableKey == nil then

			print("key = "..tableKey.." does not exists.")
		return

	end

	tableToModify[tableKey] = nil

end
end

HardFinger.PetOwnersTable = {}
PetOwnersTable = HardFinger.PetOwnersTable
function HardFinger.FindOwnerPetFromGUID(petName,petGUID) -- Credits to Recount

	local ownerName
	local ownerGUID
	local ownerRealm
	if PetOwnersTable[petGUID] ~= nil then
		return PetOwnersTable[petGUID][1], PetOwnersTable[petGUID][2]
    end

	if petGUID==UnitGUID("pet") then
		ownerName = UnitName("player")

		ownerGUID = UnitGUID("player")
		petOwnersTable[petGUID] = {ownerName, ownerGUID}
		return ownerName, ownerGUID

	end

	local raidNum = GetNumGroupMembers()

	if raidNum > 0 then

		for i = 1, raidNum, 1 do -- GetNumRaidMembers()
			if petGUID == UnitGUID("raidpet"..i) then
				ownerName, ownerRealm = UnitName("raid"..i)

				if ownerRealm then
					ownerName = ownerName .. "-" .. ownerRealm

				end
				ownerGUID = UnitGUID("raid"..i)
				petOwnersTable[petGUID] = {ownerName, ownerGUID}
				return ownerName, ownerGUID

			end

		end

	end

	print(petName.." owner not found")
	return petName, petGUID

end

function HardFinger.DamageToTarget(targetNameToTrack, desc, message, sourceGUID, sourceName, sourceFlags, destName, spellID, damageAmount, overKillAmount, absorbAmount)

	if destName == targetNameToTrack and (message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" or message == "SWING_DAMAGE") then

		local absorbed, damaged, damageDone

		if message == "SPELL_DAMAGE" or message == "SPELL_PERIODIC_DAMAGE" then

			absorbed = absorbAmount or 0

			damaged = damageAmount or 0

		else

			absorbed = absorbAmount or 0

			damaged = spellID or 0 -- For melee swings, damageAmount is the same nth parameter as spellID
			spellName = "Melee Swing"
		end


		damageDone = damaged + absorbed
		local sourceDamage = sourceName
		if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then
			sourceDamage,_ = HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID)

		end

		
		if desc ~= nil and sourceDamage ~= nil and damageDone ~= nil then -- Not necessary, but just to be safe
			HardFinger.ModifyFailTable(desc, "Damage Done ["..targetNameToTrack.."]: ", sourceDamage, damageDone)

		end
	end

end

function HardFinger.DisplayFailTable(call)

	--print("Entered function displayFailTable")
	if call == "HRESET" then

		wipe(FailTable or {})
		print("Failtable HReset")
		return

	end

	if FailTable == nil or FailTable == {} then

		print("failTable is nil")

		HardFinger.FailTableDelayTimer = nil

	else

		HardFinger.FailTableDelayTimer = HardFinger.FailTableDelayTimer or GetTime()

		if (GetTime() - HardFinger.FailTableDelayTimer) > 1 then
			print("failTable being displayed")
			for spell,spellTable in pairs(failTable) do
				local counter = ""
				if isIn(spellTable.description, {"Total times hit: ", "Deaths: "}) == true then

					counter, counter2 = HardFinger.SumVectorValues(spellTable.players)
				end

				local counter2text = ""
				if counter2 ~= nil then
					-- counter2text = "#Players: "..counter2
				end

				-- spell Icon

				if type(spellTable.spellIcon) == "string" then
					spellIconT = spellTable.spellIcon
				else

					spellIconT = (GetSpellLink(spellTable.spellIcon))
				end


				HardFinger.SendChat(spellIconT.." "..(spellTable.description)..counter..counter2text, pChannel)

				local textRows = {[1] = ""}

				local index = 1


				for _,unit in HardFinger.Spairs(spellTable.players, function(t,a,b) return t[b].counter < t[a].counter end) do
					if #textRows[index] > 150 then

						index = index + 1
					end

					textToAdd = unit.name.."  "..formatDamage(unit.counter).. ", "
					textRows[index] = (textRows[index] or "")..textToAdd
				end

				textRows[index] = textRows[index]:sub(1,#textRows[index]-2) -- Remove last ", " from the last textRow

				for i=1, #textRows do

					HardFinger.SendChat(textRows[i], pChannel)

				end

			end

		HardFinger.FailTableDelayTimer = nil
		end

	end

end

function HardFinger.Spairs(t, order)
	-- collect the keys
	local keys = {}

	for k in pairs(t) do
		keys[#keys+1] = k
	end


	-- if order function given, sort by it by passing the table and keys a, b,

	-- otherwise just sort the keys
	if order then
		table.sort(keys, function(a,b) return order(t, a, b) end)

	else
		table.sort(keys)

	end

	-- return the iterator function

	local i = 0

	return function()
		i = i + 1

		if keys[i] then

			return keys[i], t[keys[i]]

		end

	end

end

--Funcao Announce Dispel

function HardFinger.AnnounceDispel(spellToTrack, message, sourceName, destName, debuff)
	if message == "SPELL_DISPEL" then

		if param14 == spellToTrack then

			sourceName = HardFinger.SName(sourceName) -- Strip away realm name
			destName = HardFinger.SName(destName) -- Strip away realm name
			HardFinger.SendChat(sourceName.." has dispeled "..debuff.." from "..destName..".", pChannel)
		end

	end

end

function HardFinger.WhoTaunted(sourceName, destName, destRaidFlags, spellID)
	if message == "SPELL_AURA_APPLIED" then
		-- 6795 = Growl, 62124 = Hand of Reckoning, 355 = Taunt, 116189 = Provoke, 185245 = Torment, 56222 = Dark Command
	        if HardFinger.IsIn(spellID, {6795, 62124, 355, 116189, 185245, 56222}) then
			rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
			destName = HardFinger.SName(destName)
			sourceName = HardFinger.SName(sourceName)
			HardFinger.SendChat(sourceName.." "..GetSpellLink(spellID).."'d "..rIcon..destName..rIcon..".", pChannel)

		end
	end
end

function HardFinger.WhoRezzed(sourceName, destName, destRaidFlags, spellID)
	if message == "SPELL_CAST_SUCCESS" then
		--61999 = Raise Ally, 20484 = Rebirth, 20707 = Soulstone
        	if HardFinger.IsIn(spellID, {61999, 20484, 20707}) then
			rIcon = HardFinger.GetRaidMarkByFlags(destRaidFlags)
			HardFinger.SendChat(sourceName.." used "..GetSpellLink(spellID).." on "..rIcon..destName..rIcon..".", pChannel)

		end
	end
end

function HardFinger.WhoLusted()
--2825 = Blood Lust
end

HardFinger.WhoPulledTable = {}
WhoPulledTable = HardFinger.WhoPulledTable
function HardFinger.WhoPulled(name, beforeTimer, message, sourceGUID, sourceName, destGUID, destName, destFlags, spellID)
	if WhoPulledTable[destGUID] == nil then
		if (HardFinger.IsIn(destName, name) or name == "ALL") and spellID ~= 137619 and spellID ~= 203528  then

			if message == "SPELL_DAMAGE" or message == "SPELL_AURA_APPLIED" or message == "SPELL_AURA_APPLIED_DOSE" then
				if string.find(sourceGUID, "Player") or string.find(sourceGUID, "Pet") then

					if bit.band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) == 0 then

						if sourceName ~= destName then

							local name = sourceName

							WhoPulledTable[destGUID] = true

							if bit.band(sourceFlags, PET_FILTER_BITMASK) ~= 0 then -- If its a pet, get owner instead

								name = sourceName.." ("..HardFinger.SName(HardFinger.FindOwnerPetFromGUID(sourceName, sourceGUID)).."'s pet)"

							end


	                            
                    local text = HardFinger.SName(name).." aggroed "..destName.." with "..GetSpellLink(spellID)

							if beforeTimer == true and GetTime() < pullTimerDBMEnd-0.1 then

								local diff = pullTimerDBMEnd - GetTime()

								diff = format("%.1fs", diff)

								text = text.." ("..diff.." before DBM Pull)"

							end
							HardFinger.SendChat(text, pChannel)

						end

					end

				end

			end

		end
	end

end

-- Funo sName (short name, strip away realm name)

function HardFinger.SName(name)
	return name:match("(.-)-") or name

end

function HardFinger.HealAbsorbed(message, hasBuff, sourceName, destName, healabsorb)

	healabsorb = healabsorb or 0

	if message == "SPELL_HEAL" then

		if UnitDebuff(destName, hasBuff) ~= nil then

			if UnitGroupRolesAssigned(sourceName) == "HEALER" then

				--print(sourceName, "Healed", destName, "for", healabsorb, param13, param14, param15)
				HardFinger.ModifyFailTable(206610, "Healing Absorbed: ", HardFinger.SName(sourceName), healabsorb)

			end
		end
	end

end


-- Modificar fail Table, descricao = texto no chat

HardFinger.FailTable = {}
FailTable = HardFinger.FailTable
function HardFinger.ModifyFailTable(spellIconOrText, description, creatureName, amountToChange, highestAmount)
	local amountToChange = amountToChange or highestAmount or 1
	local spelln = spellIconOrText
	if type(spelln) == "number" then
		spelln = GetSpellInfo(spellIconOrText)
	end
	local uniqueTableKey = spelln..description

	--print("received: "..uniqueTableKey, spellIcon, description, creatureName, amountToChange)
	FailTable[uniqueTableKey] = FailTable[uniqueTableKey] or {}
	FailTable[uniqueTableKey].description = description

	FailTable[uniqueTableKey].spellIcon = spellIcon
	FailTable[uniqueTableKey].players = FailTable[uniqueTableKey].players or {}

	FailTable[uniqueTableKey].players[creatureName] = FailTable[uniqueTableKey].players[creatureName] or {}

	FailTable[uniqueTableKey].players[creatureName].name = creatureName
	FailTable[uniqueTableKey].players[creatureName].counter = FailTable[uniqueTableKey].players[creatureName].counter or 0

	FailTable[uniqueTableKey].players[creatureName].counter = FailTable[uniqueTableKey].players[creatureName].counter + amountToChange

	
	if highestAmount ~= nil then
		if highestAmount > FailTable[uniqueTableKey].players[creatureName].counter then

			FailTable[uniqueTableKey].players[creatureName].counter = highestAmount

		end

	end


	amountToChange = nil

end



-- Funao Send Chat

function HardFinger.SendChat(string, channel)

	-- temporary
	if P.PrivateChannel >= 5 then
		channel = "private"
	end

	if channel == "private" then
		SendChatMessage(string, "CHANNEL", nil, P.PrivateChannel)
        else

		SendChatMessage(string, channel)
	end

end

-- Somar valores para vetor
function HardFinger.SumVectorValues(vector)

	local sum = 0

	local totalEntries = 0

	for _, v in pairs(vector) do
		sum = sum + v.counter

		totalEntries = totalEntries + 1

	end
	return sum, totalEntries

end

-- Formatar damage properly
function HardFinger.FormatDamage(damage)
    local ret = damage
    if damage > 1e6 then
        ret = format("%.1f M", damage / 1e6) -- million
    elseif damage > 1e3 then
        ret = format("%.1f K", damage / 1e3) -- thousand
    end
    return ret
end

-- Funo raid target flags ICONs
function HardFinger.GetRaidMarkByFlags(flags)
    if flags == 0 then
        return "" 
    end
    local r = log(flags)/log(2) + 1
    markName = "NONE"
    if r == 1 then
        markName = "STAR"
    elseif r == 6 then
        markName = "SQUARE"
    elseif r == 7 then
        markName = "CROSS"
    elseif r == 8 then
        markName = "SKULL"
    end
    return "{rt"..r.."}",  MarkName
end

-- Funo HP Porcentagem
function HardFinger.Hpp(unit)
	return math.max(0, UnitHealth(unit)) / math.max(1, UnitHealthMax(unit)) * 100;
end